.TH AHCPD 8
.SH NAME
ahcpd \- ad-hoc configuration daemon
.SH SYNOPSIS
.B ahcpd
.IR option ...
[
.B \-\-
]
.IR interface ...
.SH DESCRIPTION
AHCP is a configuration protocol that can replace DHCP on networks without
transitive connectivity, such as mesh networks.
.SH OPTIONS
.TP
.BI \-m " multicast-address"
Speficy the link-local multicast address to be used by AHCP.
.TP
.BI \-p " port"
Specify the UDP port number to be used by AHCP.
.TP
.B \-n
Participate in the flooding protocol, but don't actually perform any
configuration.
.TP
.B \-4
Only attempt to configure IPv4 addresses.
.TP
.B \-4
Only attempt to configure IPv6 addresses.
.TP
.B \-N
Do not configure DNS.
.TP
.BI \-t " time"
Specify the time, in seconds, for which leases are requested.  The default
is slightly over one hour.
.TP
.BI \-s " script"
Specify the configuration script to run.  The default is
.BR /etc/ahcp/ahcp-config.sh .
.TP
.BI \-d " level"
Set the debug level to
.I level
(default 1).
.TP
.BI \-i " filename"
Specify the filename containing this host's unique id.  The default is
.BR /var/lib/ahcp\-unique\-id .
If it doesn't exist, it will be created by
.BR ahcpd .
.TP
.BI \-S " ipv6,first,last,dir,name-server,ntp-server"
Run as an AHCP server rather than a client.
.I Ipv6
specifies the IPv6 prefix.
.I First
and
.I last
represent the bounds of the range of IPv4 addresses available; active
leases will be stored in the directory
.IR dir ,
which should be in persistent storage (not a RAM disk).
.B Name-server
and
.B ntp-server
can be IPv4 or IPv6 addresses, and specify respectively the address of the
DNS server and of the NTP server to configure clients with.
.TP
.B \-D
Daemonise at startup.
.TP
.BI \-L " logfile"
Specify a file to log random ``how do you do?'' messages to.  This
defaults to standard error if not daemonising, and to
.B /var/log/ahcpd.log
otherwise.
.TP
.BI \-I " pidfile"
Specify a file to write our process id to.
.SH FILES
.TP
.B /var/lib/ahcp\-unique\-id
An 8-byte long file containing this host's unique id.  If it doesn't exist,
a new unique id will be generated from an interface's MAC address.
.TP
.BR /etc/ahcp/ahcp\-config.sh
The script that performs the actual configuration.  It will be passed one
argument, which is either
.B start
or
.BR stop .
.TP
.B /etc/ahcp/ahcp\-local.sh
If this is an executable script, it will be called by
.B ahcp\-config.sh
just after configuring or deconfiguring. It will be passed one
argument, which is either
.B start
or
.BR stop .
.SH SIGNALS
.TP
.B SIGUSR1
Print
.BR ahcpd 's
status to standard output or to the log file.
.TP
.B SIGUSR2
Check all interfaces for status changes, then reopen the log file.
.SH NOTES
Since the AHCP protocol is designed for mesh networks, it doesn't have any
provisions for setting routing parameters such as a default gateway, the
IPv4 network mask and the IPv6 list of on-link prefixes; these are expected
to be provided by a full-fledged routing protocol for mesh nodes, and by
router advertisements for ordinary nodes.

The AHCP server should use NTP to synchronise its clock.  If a server
instance of
.B ahcpd
doesn't detect time synchronisation, it will only give out leases for
a short period of time, and be extremely conservative about releasing them.
Note that an SNTP client is not enough \[em]
.B ahcpd
actually checks with the kernel for time synchronisation, so real NTP is
necessary.
.SH SEE ALSO
.BR dhcpcd (8),
.BR dhclient (8),
.BR babel (8),
.BR olsrd (8),
.BR ntpd (8),
.IR "The Ad-Hoc Configuration Protocol" .
.SH AUTHOR
Juliusz Chroboczek.
